package urgrip.programnodes;

import com.ur.urcap.api.contribution.ViewAPIProvider;
import com.ur.urcap.api.contribution.program.ContributionConfiguration;
import com.ur.urcap.api.contribution.program.CreationContext;
import com.ur.urcap.api.contribution.program.ProgramAPIProvider;
import com.ur.urcap.api.contribution.program.swing.SwingProgramNodeService;
import com.ur.urcap.api.domain.data.DataModel;

import java.util.Locale;

public class GripperCoupleNodeService implements SwingProgramNodeService<GripperCoupleNodeContribution, GripperCoupleNodeView> {

    @Override
    public String getId() {
        return "GripperCouple";
    }

    @Override
    public void configureContribution(ContributionConfiguration configuration) {
        configuration.setChildrenAllowed(false);
    }

    @Override
    public String getTitle(Locale locale) {
        return "Grip: Couple";
    }

    @Override
    public GripperCoupleNodeView createView(ViewAPIProvider apiProvider) {
        return new GripperCoupleNodeView(new V5Style());
    }

    @Override
    public GripperCoupleNodeContribution createNode(ProgramAPIProvider apiProvider, GripperCoupleNodeView view, DataModel model, CreationContext context) {
        return new GripperCoupleNodeContribution(apiProvider, view, model);
    }

    public GripperCoupleNodeService() {
    }
}
