package urgrip.programnodes;

import com.ur.urcap.api.contribution.ContributionProvider;
import com.ur.urcap.api.contribution.program.swing.SwingProgramNodeView;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardNumberInput;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class GripperCoupleNodeView implements SwingProgramNodeView<GripperCoupleNodeContribution>{

    private final Style style;
    private JRadioButton coupleButton, decoubleButton;

    public GripperCoupleNodeView(Style style) {
        this.style = style;
    }

    @Override
    public void buildUI(JPanel jPanel, final ContributionProvider<GripperCoupleNodeContribution> provider) {
        jPanel.setLayout(new BoxLayout(jPanel, BoxLayout.Y_AXIS));
        jPanel.add(createVerticalSpacing(style.getVerticalSpacing()));
        jPanel.add(createInput(provider));
        jPanel.add(createVerticalSpacing(style.getExtraLargeVerticalSpacing()));
    }

    private Box createInput(final ContributionProvider<GripperCoupleNodeContribution> provider) {
        Box inputBox = Box.createHorizontalBox();
        inputBox.setAlignmentX(Component.LEFT_ALIGNMENT);
        inputBox.add(new JLabel("Action:"));
        inputBox.add(createHorizontalSpacing());
        coupleButton = new JRadioButton("Couple");
        decoubleButton = new JRadioButton("Decouple");
        ButtonGroup group = new ButtonGroup();
        group.add(coupleButton);
        group.add(decoubleButton);
        inputBox.add(coupleButton);
        inputBox.add(decoubleButton);
        return inputBox;
    }

    private Component createVerticalSpacing(int height) {
        return Box.createRigidArea(new Dimension(0, height));
    }

    private Component createHorizontalSpacing() {
        return Box.createRigidArea(new Dimension(style.getHorizontalSpacing(), 0));
    }

    public void setAction(String which) {
    if(which.equals("COUPLE"))
        coupleButton.setSelected(true);
    else
        decoubleButton.setSelected(true);
    }


    public String getAction() {
        if(coupleButton.isSelected()) return "COUPLE";
        return "DECOUPLE";
    }
}
